/*
 *       Pbatt - Puppy Battery Monitor - GTK2 Icon Program v0.0.1
 *       Copyright 2008 Brad Coulthard, Coulthard@IEEE.org
 * 
 *		Feedback is great! email me.
 *
 *		This program is for Puppy Linux www.PuppyLinux.com
 *		If you use it for another disto please give me credit for my work.
 *
 *       This file is part of Pbatt.
 *
 *      Pbatt is free software: you can redistribute it and/or modify
 *       it under the terms of the GNU General Public License as published by
 *       the Free Software Foundation, either version 3 of the License, or
 *       (at your option) any later version.
 *
 *       Pbatt is distributed in the hope that it will be useful,
 *       but WITHOUT ANY WARRANTY; without even the implied warranty of
 *       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *       GNU General Public License for more details.
 *
 *       You should have received a copy of the GNU General Public License
 *       along with Pbatt.  If not, see <http://www.gnu.org/licenses/>. 
 *
 *		 compile with gcc `pkg-config --cflags --libs gtk+-2.0` Pbatt.c -o Pbatt
 */

// 21 June 2010 - modified by Gerald Pomraning to display CPU temperature as icons 
// in icewm system tray
// 	 to compile, switch to target directory & type
//	 ./Makefile



#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <glib/gstdio.h>

void tray_icon_on_click(GtkStatusIcon *status_icon, gpointer user_data);
void tray_icon_on_menu(GtkStatusIcon *status_icon, guint button,guint activate_time, gpointer user_data);
gboolean timer1(gpointer status_icon);
static GtkStatusIcon *create_tray_icon();

int main(int argc, char **argv) {
        GtkStatusIcon *tray_icon;

        gtk_init(&argc, &argv);
        tray_icon = create_tray_icon();
        g_timeout_add(2000, timer1, tray_icon);
        gtk_main();

        return 0;
}

void tray_icon_on_click(GtkStatusIcon *status_icon, gpointer user_data)
{
        system("temp_event -l");       
}


void tray_icon_on_menu(GtkStatusIcon *status_icon, guint button,guint activate_time, gpointer user_data)
{
        system("temp_event -r");
}


static GtkStatusIcon *create_tray_icon() {
        GtkStatusIcon *tray_icon;
		
        tray_icon = gtk_status_icon_new();
        g_signal_connect(G_OBJECT(tray_icon), "activate",G_CALLBACK(tray_icon_on_click), NULL);
        g_signal_connect(G_OBJECT(tray_icon),"popup-menu",G_CALLBACK(tray_icon_on_menu), NULL);
        gtk_status_icon_set_from_file(tray_icon,"apm-full.xpm");
        gtk_status_icon_set_visible(tray_icon, TRUE);

        return tray_icon;
}

gboolean timer1(gpointer status_icon) {
	FILE *fp;
	int status;
	char path[PATH_MAX];
	fp = popen("temp_event -i", "r");
	if (fp == NULL) {
		printf("ERROR: Could not open temp_event");	
	}
	fgets(path, PATH_MAX, fp);
	status = pclose(fp);
    gtk_status_icon_set_from_file(status_icon,path);
	fp = popen("temp_event -t", "r");
	fgets(path, PATH_MAX, fp);
	status = pclose(fp);
    gtk_status_icon_set_tooltip(status_icon,path);
    
}
